<?php

/*******************************************************************************
 *                                                                             *
 *                         Плагин NeoMessenger ver:2.0.1                       *
 *                              Автор: NEOm@ster                               *
 *                         http://vk.com/filinov_victor                        *
 *                                                                             *
 *******************************************************************************/

class nim {

/* -------------------------------------------------------------------------- */

    public static function isContactExists($user_id, $contact_id)
    {
        $inDB = cmsDatabase::getInstance();

        $result = $inDB->query("
            SELECT id 
            FROM cms_user_contacts 
            WHERE user_id = {$user_id} AND contact_id = {$contact_id}
            LIMIT 1
        ");

        if ($inDB->num_rows($result))
        {
            return TRUE;
        }
        else
        {
            return FALSE;
        }
    }

/* -------------------------------------------------------------------------- */

    public static function addContact($user_id, $contact_id)
    {
        $inDB = cmsDatabase::getInstance();

        $inDB->query("
            INSERT INTO cms_user_contacts (user_id, contact_id)
            VALUES ({$user_id}, {$contact_id})
        ");

        return true;
    }

/* -------------------------------------------------------------------------- */

    public static function getContacts($user_id)
    {
        $inDB = cmsDatabase::getInstance();

        $contacts[] = array(
            'id'           => '-1',
            'nickname'     => 'Уведомления',
            'avatar'       => '/plugins/p_neomessenger/img/information.png',
            'new_messages' => self::getNewNoticesCount($user_id),
            'online'       => '1'
        );

        $res = $inDB->query("
            SELECT u.id AS id, u.nickname AS nickname, u.login AS login, p.imageurl AS avatar, IFNULL(COUNT(m.id), 0) AS new_messages, IF(o.user_id, 1, 0) AS online
            FROM cms_user_contacts c
            JOIN cms_users AS u ON u.id = c.contact_id
            JOIN cms_user_profiles AS p ON p.user_id = u.id
            LEFT JOIN cms_user_msg AS m ON m.from_id = c.contact_id AND m.to_id = c.user_id AND m.is_new = 1 AND to_del = 0
            LEFT JOIN cms_online o ON o.user_id = u.id
            WHERE (c.user_id = {$user_id})
            GROUP BY c.contact_id
            ORDER BY c.date_last_msg DESC
            LIMIT 1000
        ");

        if ( ! $inDB->num_rows($res))
        {
            return $contacts;
        }

        while ($contact = $inDB->fetch_assoc($res))
        {
            $contact['avatar']     = cmsUser::getUserAvatarUrl($contact['id'], 'small', $contact['avatar']);
            $contact['profileUrl'] = cmsUser::getProfileURL($contact['login']);

            

            $contacts[] = $contact;
        }
       
        return $contacts;
    }

/* -------------------------------------------------------------------------- */

    public static function getNewNoticesCount($user_id)
    {
        $inDB = cmsDatabase::getInstance();

        return $inDB->rows_count('cms_user_msg m', "m.from_id < 0 AND m.to_id = {$user_id} AND m.is_new = 1");
    }

/* -------------------------------------------------------------------------- */

    public static function getMessages($user_id, $contact_id, $last_id = 0, $first_id = 0)
    {
        $inDB = cmsDatabase::getInstance();

        if ($last_id > 0)
        {
            $where = "AND m.id > {$last_id}";
        }
        else
        {
            if ($first_id > 0)
            {
                $where = "AND m.id < {$first_id}";
            }
            else {
                $where = "";
            }
        }

        if ($contact_id > 0)
        {
            $res = $inDB->query("
                SELECT m.*, u.id as user_id, u.nickname as author, m.from_id AS sender_id
                FROM cms_users u
                INNER JOIN cms_user_msg m ON
                    m.from_id = u.id AND
                    m.from_id IN ({$user_id}, {$contact_id}) AND
                    m.to_id IN ({$user_id}, {$contact_id})
                WHERE 1=1 {$where}
                ORDER BY m.id DESC
                LIMIT 20
            ");
        }
        else
        {
            $res = $inDB->query("
                SELECT m.*, m.from_id as sender_id
                FROM cms_user_msg m
                WHERE m.from_id < 0 AND m.to_id = {$user_id} {$where}
                ORDER BY m.id DESC
                LIMIT 20
            ");
        }
        

        if ( ! $inDB->num_rows($res))
        {
            return false;
        }

        while ($message = $inDB->fetch_assoc($res))
        {
            if ($message['from_id'] == $user_id && $message['from_del'])
            {
                continue;
            }

            if ($message['to_id'] == $user_id && $message['to_del'])
            {
                continue;
            }
            
            global $_LANG;

            if ($message['sender_id'] == USER_UPDATER)
            {
                $message['author'] = $_LANG['SERVICE_UPDATE'];
            }

            if ($message['sender_id'] == USER_MASSMAIL)
            {
                $message['author'] = $_LANG['SERVICE_MAILING'];
            }

            $message['senddate'] = cmsCore::dateFormat($message['senddate']);

            $messages[] = $message;
        }

        return is_array($messages) ? array_reverse($messages) : array();
    }

/* -------------------------------------------------------------------------- */

    public static function updateContactsDateLastMsg($user_id, $contact_id, $is_both = false)
    {
        $inDB = cmsDatabase::getInstance();

        if ($is_both)
        {
            $where = "c.user_id IN ({$user_id}, {$contact_id}) AND c.contact_id IN ({$contact_id}, {$user_id})";
        }
        else
        {
            $where = "c.user_id = {$user_id} AND c.contact_id = {$contact_id}";
        }

        $inDB->query("
            UPDATE cms_user_contacts c
            SET date_last_msg = CURRENT_TIMESTAMP
            WHERE {$where}
        ");

        return true;
    }

/* -------------------------------------------------------------------------- */

    public static function onlineUpdate($user_id)
    {
        $inDB = cmsDatabase::getInstance();

        // Собираем информацию о текущем пользователе
        $sess_id   = session_id();
        $ip        = cmsCore::strClear($_SERVER['REMOTE_ADDR']);
        $useragent = cmsCore::strClear($_SERVER['HTTP_USER_AGENT']);

        $inDB->query("DELETE FROM cms_online WHERE lastdate <= DATE_SUB(NOW(), INTERVAL " . ONLINE_INTERVAL . " MINUTE) LIMIT 5");
        $inDB->query("INSERT IGNORE INTO cms_online (ip, sess_id) VALUES ('{$ip}', '{$sess_id}') ON DUPLICATE KEY UPDATE user_id = '{$user_id}', agent = '{$useragent}'");
    }

/* -------------------------------------------------------------------------- */

    public static function getSmiles()
    {
        if ($handle = opendir(PATH . '/images/smilies'))
        {
            while (false !== ($file = readdir($handle)))
            {
                if ($file != '.' && $file != '..' && mb_strstr($file, '.gif'))
                {
                    $smiles[] = $file;
                }
            }

            closedir($handle);
        }

        return $smiles;
    }

/* -------------------------------------------------------------------------- */

}