<?php

/*******************************************************************************
 *                                                                             *
 *                         Плагин NeoMessenger ver:2.0.1                       *
 *                              Автор: NEOm@ster                               *
 *                         http://vk.com/filinov_victor                        *
 *                                                                             *
 *******************************************************************************/

    define('PATH', $_SERVER['DOCUMENT_ROOT']);

    Error_Reporting(0);

    if (@$_SERVER['HTTP_X_REQUESTED_WITH'] != 'XMLHttpRequest')
    {
        die();
    }

    session_start();

    define("VALID_CMS", 1);

    include(PATH . '/core/cms.php');
    $inCore = cmsCore::getInstance();

    cmsCore::loadClass('page');
    cmsCore::loadClass('user');
    cmsCore::loadClass('actions');

    $inDB = cmsDatabase::getInstance();
    $inConf = cmsConfig::getInstance();
    $inUser = cmsUser::getInstance();
    $inPage = cmsPage::getInstance();

    if ( ! $inUser->update())
    {
        cmsCore::halt();
    }

    global $_LANG;

    if ( ! $inUser->id)
    {
        cmsCore::halt();
    }

    $opt           = cmsCore::request('opt', 'str', '');
    $msg_id        = cmsCore::request('msg_id', 'int', 0);
    $contact_id    = cmsCore::request('contact_id', 'int', 0);
    $mess_last_id  = cmsCore::request('mess_last_id', 'int', 0);
    $mess_first_id = cmsCore::request('mess_first_id', 'int', 0);

    cmsCore::loadModel('users');
    $model_user = new cms_model_users;

    include 'nim.class.php';

/* -------------------------------------------------------------------------- */

    // Получаем количество новых сообщений
    if ($opt == 'getNewMessages')
    {
        cmsCore::jsonOutput(cmsUser::getNewMessages($inUser->id));
    }

/* -------------------------------------------------------------------------- */

    // Получаем список контактов
    if ($opt == 'getСontacts')
    {
        if ($contact_id)
        {
            $usr = cmsUser::getShortUserData($contact_id);

            // Если такого пользователя не существует выходим
            if ( ! $usr)
            {
                cmsCore::halt();
            }

            // Проверяем есть ли контакт в базе
            if ( ! nim::isContactExists($inUser->id, $contact_id))
            {
                nim::addContact($inUser->id, $contact_id);
            }
            else
            {
                nim::updateContactsDateLastMsg($inUser->id, $contact_id);
            }
        }

        $smiles        = nim::getSmiles();
        $contacts      = nim::getContacts($inUser->id);
        $bbcodetoolbar = cmsPage::getBBCodeToolbar('im-message');

        cmsCore::jsonOutput(array("contacts" => $contacts, "bbcodetoolbar" => $bbcodetoolbar, "smiles" => $smiles));
    }

/* -------------------------------------------------------------------------- */

    // Получаем сообщения от контакта
    if ($opt == 'getMessages')
    {
        // Если не указан ид выходим
        if ( ! $contact_id)
        {
            cmsCore::halt();
        }

        $messages = nim::getMessages($inUser->id, $contact_id);

        if ($messages)
        {
            $first_message_id = $messages[0]['id'];
            $has_older = (bool) $inDB->rows_count('cms_user_msg', "from_id IN ({$inUser->id}, {$contact_id}) AND to_id IN ({$inUser->id}, {$contact_id}) AND id < {$first_message_id} AND from_del = 0 AND to_del = 0", 5);
        }
        else
        {
            $first_message_id = false;
            $has_older        = false;
        }

        cmsCore::jsonOutput(array('messages' => $messages, 'has_older' => $has_older, 'older_id' => $first_message_id));
    }

/* -------------------------------------------------------------------------- */

    // Обновление списка контактов и новых сообщений
    if ($opt == 'listen')
    {
        if ( ! $contact_id)
        {
            cmsCore::halt();
        }

        nim::onlineUpdate($inUser->id);

        $contacts = nim::getContacts($inUser->id);
        $messages = nim::getMessages($inUser->id, $contact_id, $mess_last_id);

        cmsCore::jsonOutput(array("contacts" => $contacts, "messages" => $messages));
    }

/* -------------------------------------------------------------------------- */

    // Удаляем сообщение
    if ($opt == 'delMessage')
    {
        $id = cmsCore::request('id', 'int', 0);

        $msg = $inDB->get_fields('cms_user_msg', "id={$id}", '*');

        if ( ! $msg)
        {
            cmsCore::halt();
        }

        // Сообщение мне от пользователя
        if ($msg['to_id'] == $inUser->id)
        {
            if ($msg['from_id'] > 0)
            {
                $inDB->query("UPDATE cms_user_msg SET to_del=1 WHERE id={$id}");
            }
            else
            {
                $inDB->query("DELETE FROM cms_user_msg WHERE id={$id} LIMIT 1");
            }
        }

        // Сообщение от меня пользователю
        if ($msg['from_id'] == $inUser->id)
        {
            if ($msg['is_new'])
            {
                $inDB->query("DELETE FROM cms_user_msg WHERE id = {$id} LIMIT 1");
            }
            else
            {
                $inDB->query("UPDATE cms_user_msg SET from_del=1 WHERE id={$id}");
            }
        }

        // Удаляем сообщения, которые удалены с двух сторон
        $inDB->query("DELETE FROM cms_user_msg WHERE to_del=1 AND from_del=1");

        cmsCore::jsonOutput(array('error' => false));
    }

/* -------------------------------------------------------------------------- */

    // Удаляем сообщение
    if ($opt == 'delContact')
    {
        $id = cmsCore::request('id', 'int', 0);

        // Проверяем есть ли контакт в базе
        if (nim::isContactExists($inUser->id, $id))
        {
            $inDB->query("DELETE FROM cms_user_contacts WHERE user_id={$inUser->id} AND contact_id={$id}");
        }

        cmsCore::jsonOutput(array('error' => false));
    }

/* -------------------------------------------------------------------------- */

    // Отправка сообщения
    if ($opt == 'sendMessage')
    {
        $message = cmsCore::request('message', 'html', '');
        $message = cmsCore::parseSmiles($message, true);

        if ( ! nim::isContactExists($contact_id, $inUser->id))
        {
            nim::addContact($contact_id, $inUser->id);
        }

        nim::updateContactsDateLastMsg($inUser->id, $contact_id, true);

        // Отправляем сообщение
        $message_id = cmsUser::sendMessage($inUser->id, $contact_id, $message);

        // Отправляем уведомление на email если нужно
        $model_user->sendNotificationByEmail($contact_id, $inUser->id, $message_id);

        cmsCore::jsonOutput(array('messages' => nim::getMessages($inUser->id, $contact_id, $mess_last_id)));
    }

/* -------------------------------------------------------------------------- */

    // Отмечает сообщение как прочитанное
    if ($opt == 'setMsgReaded')
    {
        $inDB->query("UPDATE cms_user_msg m SET is_new = 0 WHERE m.id = {$msg_id} LIMIT 1");
    }

/* -------------------------------------------------------------------------- */

    // Показывает старые сообщения
    if ($opt == 'showOld')
    {
        $messages = nim::getMessages($inUser->id, $contact_id, 0, $mess_first_id);

        if ($messages)
        {
            $first_message_id = $messages[0]['id'];
            $has_older = (bool) $inDB->rows_count('cms_user_msg', "from_id IN ({$inUser->id}, {$contact_id}) AND to_id IN ({$inUser->id}, {$contact_id}) AND id < {$first_message_id} AND from_del = 0 AND to_del = 0", 5);
        }
        else
        {
            $first_message_id = false;
            $has_older        = false;
        }

        cmsCore::jsonOutput(array("messages" => array_reverse($messages), "has_older" => $has_older, "older_id" => $first_message_id)); 
    }

/* -------------------------------------------------------------------------- */

    cmsCore::halt();