<?php

/*******************************************************************************
 *                                                                             *
 *                         Плагин NeoMessenger ver:2.0.1                       *
 *                              Автор: NEOm@ster                               *
 *                         http://vk.com/filinov_victor                        *
 *                                                                             *
 *******************************************************************************/

class p_neomessenger extends cmsPlugin {

    public function __construct()
    {
        parent::__construct();

        // Информация о плагине

        $this->info['plugin']      = 'p_neomessenger';
        $this->info['title']       = 'NeoMessenger';
        $this->info['description'] = 'Переписка в всплывающем окне на аякс';
        $this->info['author']      = '<a target="_blank" href="http://vk.com/filinov_victor">NEOm@ster</a>';
        $this->info['version']     = '2.0.1';

        // Настройки по-умолчанию

        $this->config['таймаут обновления чата (сек)'] = 20;

        // События, которые будут отлавливаться плагином

        $this->events[] = 'PRINT_PAGE_HEAD';
    }

/* -------------------------------------------------------------------------- */

    /**
     * Процедура установки плагина
     * @return bool
     */
    public function install()
    {
        $inDB = cmsDatabase::getInstance();

        // При повторной установке во избежание дублей удаляем старую таблицу
        $inDB->query('DROP TABLE IF EXISTS cms_user_contacts');

        // Создаем таблицу для хранения списка контактов
        $inDB->query('
            CREATE TABLE cms_user_contacts (
              id int(11) NOT NULL AUTO_INCREMENT,
              user_id int(11) DEFAULT NULL,
              contact_id int(11) DEFAULT NULL,
              date_last_msg timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
              PRIMARY KEY (id),
              KEY user_id (user_id),
              KEY contact_id (contact_id)
            ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
        ');

        // Извлекаем из таблицы с сообщениями всех отправителей и получателей
        $res = $inDB->query('
            SELECT from_id, to_id, from_del, to_del
            FROM cms_user_msg
            ORDER BY senddate ASC
        ');

        if ($inDB->num_rows($res))
        {
            $values = array();

            // Формируем список контактов
            while ($item = $inDB->fetch_assoc($res))
            {
                if ( ! (int) $item['from_del'])
                {
                    $value = array((int) $item['from_id'], (int) $item['to_id']);

                    if ( ! in_array($value, $values) AND $value[0] > 0)
                    {
                        $values[] = $value;
                        $inDB->query("INSERT INTO cms_user_contacts (user_id, contact_id) VALUES ({$value[0]}, {$value[1]})");
                    }
                }

                if ( ! (int) $item['to_del'])
                {
                    $value = array((int) $item['to_id'], (int) $item['from_id']);

                    if ( ! in_array($value, $values) AND $value[0] > 0)
                    {
                        $values[] = $value;
                        $inDB->query("INSERT INTO cms_user_contacts (user_id, contact_id) VALUES ({$value[0]}, {$value[1]})");
                    }
                }
            }
        }

        return parent::install();
    }

/* -------------------------------------------------------------------------- */

    // Обновление плагина
    public function upgrade()
    {
        return parent::upgrade();
    }

/* -------------------------------------------------------------------------- */
    
    /**
     * Обработка событий
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
    public function execute($event = '', $item = array())
    {
        parent::execute();

        switch ($event)
        {
            case 'PRINT_PAGE_HEAD': $item = $this->AddPluginToPage($item); break;
        }

        return $item;
    }

/* -------------------------------------------------------------------------- */

    /**
     * Добавление файлов плагина на страницу
     */
    private function AddPluginToPage($head)
    {
        $inUser = cmsUser::getInstance();

        if ( ! $inUser->id)
        {
            return $head;
        }

        $inPage = cmsPage::getInstance();

        // Передаем плагину период обновления и ид юзера
        $inPage->addHead("
            <script>
                var NIM = {
                    userId: {$inUser->id},
                    upTime: {$this->config['таймаут обновления чата (сек)']}
                };
            </script>
        ");

        // Подключаем стили и скрипты
        $inPage->addHeadCSS('plugins/p_neomessenger/css/style.css?no_cache=1000');
        $inPage->addHeadJS('components/users/js/profile.js');
        $inPage->addHeadJS('core/js/smiles.js');            
        $inPage->addHeadJS('includes/jquery/upload/ajaxfileupload.js');            
        $inPage->addHeadJS('plugins/p_neomessenger/js/window.js?no_cache=1000');
        $inPage->addHeadJS('plugins/p_neomessenger/js/messenger.js?no_cache=1003');

        // Возвращаем head
        return $inPage->page_head;
    }

/* -------------------------------------------------------------------------- */

}